"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const formatWarn_1 = __importDefault(require("./utils/formatWarn"));
const most = require("most");
const prettyMilliseconds = require("pretty-ms");
exports.default = (requestRetry$) => {
    return requestRetry$
        .map((log) => {
        const retriesLeft = log.maxRetries - log.attempt + 1;
        const errorCode = log.error['httpStatusCode'] || log.error['status'] || log.error['errno'] || log.error['code'];
        // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
        const msg = `${log.method} ${log.url} error (${errorCode}). \
Will retry in ${prettyMilliseconds(log.timeout, { verbose: true })}. \
${retriesLeft} retries left.`;
        return most.of({ msg: formatWarn_1.default(msg) });
    });
};
//# sourceMappingURL=reportRequestRetry.js.map