"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const R = require("ramda");
const sortPackages = R.sortBy(R.prop('name'));
async function default_1(pkgs, opts) {
    return pkgs.map((pkg) => renderParseableForPackage(pkg, opts)).join('\n');
}
exports.default = default_1;
function renderParseableForPackage(pkg, opts) {
    var _a, _b, _c, _d;
    const pkgs = sortPackages(flatten([
        ...((_a = pkg.optionalDependencies) !== null && _a !== void 0 ? _a : []),
        ...((_b = pkg.dependencies) !== null && _b !== void 0 ? _b : []),
        ...((_c = pkg.devDependencies) !== null && _c !== void 0 ? _c : []),
        ...((_d = pkg.unsavedDependencies) !== null && _d !== void 0 ? _d : []),
    ]));
    if (!opts.alwaysPrintRootPackage && !pkgs.length)
        return '';
    if (opts.long) {
        let firstLine = pkg.path;
        if (pkg.name) {
            firstLine += `:${pkg.name}`;
            if (pkg.version) {
                firstLine += `@${pkg.version}`;
            }
        }
        return [
            firstLine,
            ...pkgs.map((pkg) => `${pkg.path}:${pkg.name}@${pkg.version}`),
        ].join('\n');
    }
    return [
        pkg.path,
        ...pkgs.map((pkg) => pkg.path),
    ].join('\n');
}
function flatten(nodes) {
    var _a;
    let packages = [];
    for (const node of nodes) {
        packages.push(node);
        if ((_a = node.dependencies) === null || _a === void 0 ? void 0 : _a.length) {
            packages = packages.concat(flatten(node.dependencies));
        }
    }
    return packages;
}
//# sourceMappingURL=renderParseable.js.map