"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const validateNpmPackageName = require("validate-npm-package-name");
function parseWantedDependency(rawWantedDependency) {
    const versionDelimiter = rawWantedDependency.indexOf('@', 1); // starting from 1 to skip the @ that marks scope
    if (versionDelimiter !== -1) {
        const alias = rawWantedDependency.substr(0, versionDelimiter);
        if (validateNpmPackageName(alias).validForOldPackages) {
            return {
                alias,
                pref: rawWantedDependency.substr(versionDelimiter + 1),
            };
        }
        return {
            pref: rawWantedDependency,
        };
    }
    if (validateNpmPackageName(rawWantedDependency).validForOldPackages) {
        return {
            alias: rawWantedDependency,
        };
    }
    return {
        pref: rawWantedDependency,
    };
}
exports.default = parseWantedDependency;
//# sourceMappingURL=index.js.map